/*******************************************************************************
 * Copyright (C) 2018 THL A29 Limited, a Tencent company.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Tencent - support multiple contexts
 ******************************************************************************/
package com.eclipsesource.v8;

/**
 * Created by LiYongjie on 2018/3/15.
 */
/*package*/final class V8ContextSessionMgr {
    private final V8 v8;
    private V8ContextWrapper currentContext;

    V8ContextSessionMgr(V8 v8) {
        this.v8 = v8;
    }

    public void enterContext(V8ContextWrapper context) {
        if (context == null) {
            return;
        }

        if (context.equals(currentContext)) {
            return;
        }

        v8.switchV8Context(context.getPtr());
        currentContext = context;
    }

    public void releaseContext(V8ContextWrapper context) {
        if (context == null) {
            return;
        }

        v8.releaseV8Context(context.getPtr());
    }
}
